// headers

#include <string.h>
#include <stdio.h>


#define WIDTH 80
#define HEIGHT 25

// rle decoding to fixed x/y buffer
// orange = F6B21A
// blue = 2A3172

#include "data.c"

void rle_buf_write(char *output_pointer, const char *rle_buffer, char value) {
    while (*rle_buffer) {
        // don't touch this part
        output_pointer += *rle_buffer++;
        // write stuff
        char len = *rle_buffer++;
        while (len) {
            len--;
            *output_pointer++ = value;
        }
    }
}

void rle_buf_write_compressed(char *output_pointer, const unsigned char *rle_buffer) {
    // format: upper 2 bits are color, lower 6 are run length.
    while (*rle_buffer) {
        unsigned char color = *rle_buffer >> 6;
        unsigned char length = *rle_buffer++ & 0x3F;
        switch (color) {
            case 0:
                color = ' ';
                break;
            case 1:
                color = '5';
                break;
            case 2:
                color = 'R';
                break;
        }

        while (length--) {
            *output_pointer++ = color;
        }
    }
}


int main() {
    char test_buffer[WIDTH*HEIGHT];

    memset(test_buffer, ' ', WIDTH * HEIGHT);
    //rle_buf_write(test_buffer, rle_yellow_codes, 'X');
    //rle_buf_write(test_buffer, rle_blue_codes, 'O');
    rle_buf_write_compressed(test_buffer, rle_logo_data);
    for (unsigned char i = 0; i < HEIGHT; i++) {
        fwrite(test_buffer + WIDTH * i, WIDTH, 1,  stdout);
        fwrite("\n", 1, 1, stdout);
    }
}
