; Copyright © 2022, Nathan Egge (unlord / xylem)
; All rights reserved.
;
; Redistribution and use in source and binary forms, with or without
; modification, are permitted provided that the following conditions are met:
;
; 1. Redistributions of source code must retain the above copyright notice, this
;    list of conditions and the following disclaimer.
;
; 2. Redistributions in binary form must reproduce the above copyright notice,
;    this list of conditions and the following disclaimer in the documentation
;    and/or other materials provided with the distribution.
;
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
; ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
; WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
; DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
; ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
; (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
; ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
; (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
; SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

; ELF64 header from https://gitlab.com/unlord/elf-hacks
; nasm elf64.asm -o elf64
              org     0x00010000

ehdr:                                                 ; elf64_hdr
              db      0x7F, "ELF", 2, 1, 1, 0         ;   e_ident
      times 8 db      0
              dw      2                               ;   e_type
              dw      0xf3                            ;   e_machine
              dd      1                               ;   e_version
              dq      _start                          ;   e_entry
              dq      phdr - $$                       ;   e_phoff

_start:       ; your program here (max 12 bytes)

              dd      0x05000993   ; li   s3, 80
              dw      0x4911       ; c.li s2, 4
              dd      0x02000a93   ; li   s5, 32
              dw      0xa83d       ; j    intro

              dw      ehdrsize                        ;   e_ehsize
              dw      phdrsize                        ;   e_phentsize
phdr:                                                                   ; elf64_phdr
              dw      1                               ;   e_phnum       ;   p_type
              dw      0                               ;   e_shentsize
              dw      7                               ;   e_shnum       ;   p_flags
              dw      0                               ;   e_shstrndx

ehdrsize      equ     $ - ehdr

              dq      0                                                 ;   p_offset
              dq      $$                                                ;   p_vaddr
              dq      $$                                                ;   p_paddr
              dq      filesize                                          ;   p_filesz
              dq      filesize                                          ;   p_memsz
              dq      0x1000                                            ;   p_align

phdrsize      equ     $ - phdr

intro:
incbin "risc-vision.release.body"

filesize      equ     $ - $$
